setwd("~/_home_seifert_Projekte/Whiskey_NMR/subprojects/02_RF/scripts/WS_run.R")
source("init.R")
num.trees.RF = 10
mtry = as.integer(287^(3/4))
s = 15
t = 5
rerun = FALSE

se = loadObject(file = file.path(project.dir, "/subprojects/01_pretreatment/data/sum_exp_norm.RData"))
samples = colData(se)
maxsamp = 100

set.seed(42)
samples.scot = sample(which(samples[,"Country"] == "Scotland"), maxsamp)

#create se with relevant samples with class number at least 10
se.country = se[, c(samples.scot, which( samples[,"Country"] == "Germany" |
                                           samples[,"Country"] == "Ireland" |
                                           samples[,"Country"] == "USA" |
                                           samples[,"Country"] == "Canada" |
                                           samples[,"Country"] == "Japan" 
))]


if (rerun) {
  set.seed(42)
  res.all = RF.analysis.all(sum.exp = se.country,
                            num.trees.RF = num.trees.RF,
                            assay = "original",
                            var.y = "Country",
                            mtry = mtry,
                            s = s,
                            t = t,
                            VarAnal = TRUE)
  
  saveObject(res.all, file = file.path(data.dir,paste0("res_country",num.trees.RF,"_s_",s,"_t_",t,".RData")))
print("finished 1")
} else {
  res.all = loadObject(file = file.path(data.dir,paste0("res_country",num.trees.RF,"_s_",s,"_t_",t,".RData")))
}


#create se with relevant samples with class number at least 10
se.usa = se[, which( samples[,"Region"] == " Kentucky" |
                       samples[,"Region"] == "Tennessee"
)]

se.scotland = se[, which( samples[,"Region"] == "Speyside" |
                            samples[,"Region"] == "Campbeltown" |
                            samples[,"Region"] == "Highlands" |
                            samples[,"Region"] == "Islay" |
                            samples[,"Region"] == "Isle of Jura" |
                            samples[,"Region"] == "Isle of Mull" |
                            samples[,"Region"] == "Lowlands" |
                            samples[,"Region"] == "Orkney" 
)]

se.scotland = se[, which( samples[,"Country"] == "Scotland")]
samples.scot = colData(se.scotland)



if (rerun) {
  set.seed(42)
  res.usa = RF.analysis.all(sum.exp = se.usa,
                            num.trees.RF = num.trees.RF,
                            assay = "original",
                            var.y = "Region",
                            mtry = mtry,
                            s = s,
                            t = t,
                            VarAnal = TRUE)
  
  saveObject(res.usa, file = file.path(data.dir,paste0("res_region_usa",num.trees.RF,"_s_",s,"_t_",t,".RData")))
  
  set.seed(42)
  res.scot = RF.analysis.all(sum.exp = se.scotland,
                             num.trees.RF = num.trees.RF,
                             assay = "original",
                             var.y = "Region",
                             mtry = mtry,
                             s = s,
                             t = t,
                             VarAnal = TRUE)
  
  saveObject(res.scot, file = file.path(data.dir,paste0("res_region_scotland",num.trees.RF,"_s_",s,"_t_",t,".RData")))
 print("finished 2") 
} else {
  res.usa = loadObject(file = file.path(data.dir,paste0("res_region_usa",num.trees.RF,"_s_",s,"_t_",t,".RData")))
  
  res.scot = loadObject(file = file.path(data.dir,paste0("res_region_scotland",num.trees.RF,"_s_",s,"_t_",t,".RData")))
}



#create ses with Barells: Ex-Sherry, Ex-Bourbon and both for all samples and for samples from Islay and Speyside

se.barell = se[, which( samples[,"Barell"] == "Ex-Sherry" |
                          samples[,"Barell"] == "Ex-Bourbon" |
                          samples[,"Barell"] == "Ex-Bourbon, Ex-Sherry" 
)]

#  For samples from Speyside 
se.speyside= se[, which( samples[,"Region"] == "Speyside" )]
samples.speyside = colData(se.speyside)
se.speyside= se.speyside[, which( samples.speyside[,"Barell"] == "Ex-Sherry" |
                                    samples.speyside[,"Barell"] == "Ex-Bourbon" |
                                    samples.speyside[,"Barell"] == "Ex-Bourbon, Ex-Sherry" 
)]

#  For samples from Islay 
se.islay= se[, which( samples[,"Region"] == "Islay" )]
samples.islay = colData(se.islay)
se.islay= se.islay[, which( samples.islay[,"Barell"] == "Ex-Sherry" |
                              samples.islay[,"Region"] == "Ex-Bourbon" |
                              samples.islay[,"Region"] == "Ex-Bourbon, Ex-Sherry" 
)]




if (rerun) {
  set.seed(42)
  res.barell = RF.analysis.all(sum.exp = se.barell,
                               num.trees.RF = num.trees.RF,
                               assay = "original",
                               var.y = "Barell",
                               mtry = mtry,
                               s = s,
                               t = t,
                               VarAnal = TRUE)
  
  
  saveObject(res.barell, file = file.path(data.dir,paste0("res_barell",num.trees.RF,"_s_",s,"_t_",t,".RData")))
  
  set.seed(42)
  res.speyside = RF.analysis.all(sum.exp = se.speyside,
                                 num.trees.RF = num.trees.RF,
                                 assay = "original",
                                 var.y = "Barell",
                                 mtry = mtry,
                                 s = s,
                                 t = t,
                                 VarAnal = TRUE)
  
  saveObject(res.speyside, file = file.path(data.dir,paste0("res_speyside",num.trees.RF,"_s_",s,"_t_",t,".RData")))
  
  
  set.seed(42)
  res.islay = RF.analysis.all(sum.exp = se.islay,
                              num.trees.RF = num.trees.RF,
                              assay = "original",
                              var.y = "Barell",
                              mtry = mtry,
                              s = s,
                              t = t,
                              VarAnal = TRUE)
  
  saveObject(res.islay, file = file.path(data.dir,paste0("res_islay",num.trees.RF,"_s_",s,"_t_",t,".RData")))
 print("finished 3") 
  
  
} else {
  res.barell = loadObject(file = file.path(data.dir,paste0("res_barell",num.trees.RF,"_s_",s,"_t_",t,".RData")))
  res.speyside = loadObject(file = file.path(data.dir,paste0("res_speyside",num.trees.RF,"_s_",s,"_t_",t,".RData")))
  res.islay = loadObject(file = file.path(data.dir,paste0("res_islay",num.trees.RF,"_s_",s,"_t_",t,".RData")))
}



#create se

se.colour = se[, which( samples[,"colour"] == "natural Colour" |
                          samples[,"colour"] == "plain caramel" 
)]



if (rerun) {
  set.seed(42)
  res.colour = RF.analysis.all(sum.exp = se.colour,
                               num.trees.RF = num.trees.RF,
                               assay = "original",
                               var.y = "colour",
                               mtry = mtry,
                               s = s,
                               t = t,
                               VarAnal = TRUE)
  
  
  saveObject(res.colour, file = file.path(data.dir,paste0("res_colour",num.trees.RF,"_s_",s,"_t_",t,".RData")))
  print("finished 4")
  
} else {
  res.colour = loadObject(file = file.path(data.dir,paste0("res_colour",num.trees.RF,"_s_",s,"_t_",t,".RData")))
}



#create se

se.age = se[, which( samples[,"Age"] != "NAS" 
)]



if (rerun) {
  set.seed(42)
  res.age = RF.analysis.all(sum.exp = se.age,
                            num.trees.RF = num.trees.RF,
                            assay = "original",
                            var.y = "Age",
                            mtry = mtry,
                            s = s,
                            t = t,
                            type = "regression",
                            VarAnal = TRUE)
  
  
  saveObject(res.age, file = file.path(data.dir,paste0("res_age",num.trees.RF,"_s_",s,"_t_",t,".RData")))
  print("finished 5")
  
} else {
  res.age = loadObject(file = file.path(data.dir,paste0("res_age",num.trees.RF,"_s_",s,"_t_",t,".RData")))
}
