
## information about directories
subproject.dir = dirname(getwd())
project.dir = dirname(dirname(subproject.dir))

## data
input.dir = file.path(project.dir, "data_input")
data.dir = file.path(subproject.dir, "data")

## analysis
plots.dir = file.path(subproject.dir, "img")

## functions
functions.dir = file.path(subproject.dir, "R_functions")

## load libraries
require(DT)               ## interactive tables
require(R.utils)          ## loadObject(), saveObject()
require(summarytools)
require(SummarizedExperiment)

## replace = with <-; set code/output width to be 68
#options(replace.assign=TRUE)


## functions
files = dir(functions.dir, pattern = ".R*", full.name = TRUE)
if (length(files) > 0) {
  print(paste("loading", length(files), "file(s) ..."))
  for (f in files) {
    source(f)  
  }
}


set.dir = function(dir) {
  if (!file.exists(dir)) {
    dir.create(dir, recursive = TRUE)
  }
  return(dir)
}

get.no.lines = function(f) {
  temp = system(paste("wc -l", f), intern = TRUE)
  return(as.numeric(unlist(strsplit(temp, " "))[1]))
}



